﻿using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Win.Templates.Bars.ActionControls;
using DevExpress.XtraBars;

namespace Solution2.Module.Win
{
	public class CustomBarButtonItemSingleChoiceActionControl : BarButtonItemSingleChoiceActionControl
	{
		private PopupMenu PopupMenu
		{
			get
			{
				return (PopupMenu)this.BarItem.DropDownControl;
			}
		}

		public string AggregatedActionConfirmationMessage { get; set; }

		protected override void OnEndInit()
		{
			this.BarItem.ItemClick += BarItem_ItemClick;
			base.OnEndInit();
			this.PopupMenu.LinkAdded += PopupMenu_LinkAdded;
			this.PopupMenu.LinkDeleted += PopupMenu_LinkDeleted;
		}

		private void BarItem_ItemClick(object sender, ItemClickEventArgs e)
		{
			this.SetConfirmationMessage(this.AggregatedActionConfirmationMessage);
		}

		private void PopupMenu_LinkDeleted(object sender, LinkEventArgs e)
		{
			if (e.Link.Item is BarButtonItem barButtonItem)
				barButtonItem.ItemClick -= BarButtonItem_ItemClick;
		}

		private void PopupMenu_LinkAdded(object sender, LinkEventArgs e)
		{
			if( e.Link.Item is BarButtonItem barButtonItem)
				barButtonItem.ItemClick += BarButtonItem_ItemClick;
		}

		private void BarButtonItem_ItemClick(object sender, ItemClickEventArgs e)
		{
			this.SetConfirmationMessage(this.ActionItemByBarItem[e.Item].Data as ActionBase);
		}

		private  void SetConfirmationMessage(ActionBase action)
		{
			if (action == null) return;
			var formattedConfirmationMessage = action.GetFormattedConfirmationMessage();
			this.SetConfirmationMessage(formattedConfirmationMessage); 
		}
	}
}
